library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity route is 
    generic( 
        INPUT_WIDTH: integer := GENERIC_INPUT_WIDTH_PARAM;
        OUTPUT_WIDTH: integer := GENERIC_OUTPUT_WIDTH_PARAM
    );
    port(
        PRM_ERROR : out std_logic_vector(3 downto 0);

        OUTPUT_FU1 : in std_logic_vector(OUTPUT_WIDTH-1 downto 0);    
        OUTPUT_FU2 : in std_logic_vector(OUTPUT_WIDTH-1 downto 0);
        OUTPUT_FU3 : in std_logic_vector(OUTPUT_WIDTH-1 downto 0);
        OUTPUT_VOTER : in std_logic_vector(OUTPUT_WIDTH-1 downto 0);
        OUTPUT_VOTER_ERROR : in std_logic_vector(3 downto 0);

        OUTPUT     : out std_logic_vector(OUTPUT_WIDTH-1 downto 0); 
        
        INPUT      : in std_logic_vector(INPUT_WIDTH-1 downto 0);

        INPUT_VOTER_FU1  : out std_logic_vector(OUTPUT_WIDTH-1 downto 0);
        INPUT_VOTER_FU2  : out std_logic_vector(OUTPUT_WIDTH-1 downto 0);
        INPUT_VOTER_FU3  : out std_logic_vector(OUTPUT_WIDTH-1 downto 0);
    
        INPUT_FU1  : out std_logic_vector(INPUT_WIDTH-1 downto 0);
        INPUT_FU2  : out std_logic_vector(INPUT_WIDTH-1 downto 0);
        INPUT_FU3  : out std_logic_vector(INPUT_WIDTH-1 downto 0)          
    ); 
end route;


architecture route_behavioral of route is
begin
    INPUT_VOTER_FU1 <= OUTPUT_FU1;
    INPUT_VOTER_FU2 <= OUTPUT_FU2;
    INPUT_VOTER_FU3 <= OUTPUT_FU3;
    OUTPUT <= OUTPUT_VOTER;

    -- pripojeni vstupu vsech tri jednotek k vstupnim signalum 
    INPUT_FU1 <= INPUT;
    INPUT_FU2 <= INPUT;
    INPUT_FU3 <= INPUT;     
    
    PRM_ERROR <= OUTPUT_VOTER_ERROR; 
end route_behavioral;
