library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity route is 
    generic( 
        INPUT_WIDTH: integer := GENERIC_INPUT_WIDTH_PARAM;
        OUTPUT_WIDTH: integer := GENERIC_OUTPUT_WIDTH_PARAM
    );
    port(
        PRM_ERROR : out std_logic_vector(3 downto 0);

        OUTPUT_FU1 : in std_logic_vector(OUTPUT_WIDTH-1 downto 0);    
        OUTPUT_FU2 : in std_logic_vector(OUTPUT_WIDTH-1 downto 0);
        OUTPUT_FU3 : in std_logic_vector(OUTPUT_WIDTH-1 downto 0);

        OUTPUT     : out std_logic_vector(OUTPUT_WIDTH-1 downto 0); 
        
        INPUT      : in std_logic_vector(INPUT_WIDTH-1 downto 0);

        INPUT_FU1  : out std_logic_vector(INPUT_WIDTH-1 downto 0);
        INPUT_FU2  : out std_logic_vector(INPUT_WIDTH-1 downto 0);
        INPUT_FU3  : out std_logic_vector(INPUT_WIDTH-1 downto 0)       
    ); 
end route;


architecture route_behavioral of route is

signal tmp1Cout, tmp2Cout, errC, err1, err2 : std_logic;
    


begin
    -- OUTPUT_FU2 = output of checker unit    
    tmp1Cout <= '0' when OUTPUT_FU1=OUTPUT_FU2 else '1';
    tmp2Cout <= '0' when OUTPUT_FU2=OUTPUT_FU3 else '1';    
    errC <= tmp1Cout and tmp2Cout;
    err1 <= tmp1Cout and not errC;
    err2 <= tmp2Cout and not errC;



    OUTPUT <= OUTPUT_FU1 when (err1='0') else OUTPUT_FU3;
    PRM_ERROR(0) <= errC;
    PRM_ERROR(1) <= err1; 
    PRM_ERROR(2) <= err2;
    PRM_ERROR(3) <= '0';
    
    -- pripojeni vstupu vsech tri jednotek k vstupnim signalum 
    INPUT_FU1 <= INPUT;
    INPUT_FU2 <= INPUT;
    INPUT_FU3 <= INPUT;     
end route_behavioral;
